upstream: regression test for UnusedConnectionTimeout

OpenBSD-Regress-ID: 7f29001374a68e71e5e078f69e4520cf4bcca084
This commit is contained in:
djm@openbsd.org 2023-01-17 10:02:34 +00:00 committed by Damien Miller
parent aff9493a89
commit cef2593c33
No known key found for this signature in database
2 changed files with 79 additions and 1 deletions

View File

@ -102,7 +102,8 @@ LTESTS= connect \
knownhosts-command \
agent-restrict \
hostbased \
channel-timeout
channel-timeout \
connection-timeout
INTEROP_TESTS= putty-transfer putty-ciphers putty-kex conch-ciphers
#INTEROP_TESTS+=ssh-com ssh-com-client ssh-com-keygen ssh-com-sftp

View File

@ -0,0 +1,77 @@
# $OpenBSD: connection-timeout.sh,v 1.1 2023/01/17 10:02:34 djm Exp $
# Placed in the Public Domain.
tid="unused connection timeout"
CTL=$OBJ/ctl-sock
cp $OBJ/sshd_proxy $OBJ/sshd_proxy.orig
check_ssh() {
test -S $CTL || return 1
if ! ${REAL_SSH} -qF$OBJ/ssh_proxy -O check \
-oControlPath=$CTL somehost >/dev/null 2>&1 ; then
return 1
fi
return 0
}
start_ssh() {
trace "start ssh"
${SSH} -nNfF $OBJ/ssh_proxy "$@" -oExitOnForwardFailure=yes \
-oControlMaster=yes -oControlPath=$CTL somehost
r=$?
test $r -eq 0 || fatal "failed to start ssh $r"
check_ssh || fatal "ssh process unresponsive"
}
stop_ssh() {
test -S $CTL || return
check_ssh || fatal "ssh process is unresponsive: cannot close"
if ! ${REAL_SSH} -qF$OBJ/ssh_proxy -O exit \
-oControlPath=$CTL >/dev/null somehost >/dev/null ; then
fatal "ssh process did not respond to close"
fi
n=0
while [ "$n" -lt 20 ] ; do
test -S $CTL || break
sleep 1
n=`expr $n + 1`
done
if test -S $CTL ; then
fatal "ssh process did not exit"
fi
}
trap "stop_ssh" EXIT
verbose "no timeout"
start_ssh
sleep 5
check_ssh || fatal "ssh unexpectedly missing"
stop_ssh
(cat $OBJ/sshd_proxy.orig ; echo "UnusedConnectionTimeout 2") > $OBJ/sshd_proxy
verbose "timeout"
start_ssh
sleep 8
check_ssh && fail "ssh unexpectedly present"
stop_ssh
verbose "timeout after session"
start_ssh
${REAL_SSH} -qoControlPath=$CTL -oControlMaster=no -Fnone somehost "exit 0" ||
fail "session failed"
sleep 8
check_ssh && fail "ssh unexpectedly present"
stop_ssh
LPORT=`expr $PORT + 1`
RPORT=`expr $LPORT + 1`
DPORT=`expr $RPORT + 1`
RDPORT=`expr $DPORT + 1`
verbose "timeout with listeners"
start_ssh -L$LPORT:127.0.0.1:$PORT -R$RPORT:127.0.0.1:$PORT -D$DPORT -R$RDPORT
sleep 8
check_ssh && fail "ssh unexpectedly present"
stop_ssh